# -*- Mode: Python -*-

import sys
import Parsing

T = Parsing.Token
NT = Parsing.Nonterm

class t_DEDENT (T):
    "%token DEDENT [p1]"

class t_and (T):
    "%token and [p1]"

class t_elif (T):
    "%token elif [p1]"

class t_semicolon (T):
    "%token semicolon [p1]"

class t_is (T):
    "%token is [p1]"

class t_pass (T):
    "%token pass [p1]"

class t_NUMBER (T):
    "%token NUMBER [p1]"

class t_colon (T):
    "%token colon [p1]"

class t_in (T):
    "%token in [p1]"

class t_if (T):
    "%token if [p1]"

class t_NEWLINE (T):
    "%token NEWLINE [p1]"

class t_percent (T):
    "%token percent [p1]"

class t_slash (T):
    "%token slash [p1]"

class t_print (T):
    "%token print [p1]"

class t_slashslash (T):
    "%token slashslash [p1]"

class t_STRING (T):
    "%token STRING [p1]"

class t_equals (T):
    "%token equals [p1]"

class t_else (T):
    "%token else [p1]"

class t_not (T):
    "%token not [p1]"

class t_splat (T):
    "%token splat [p1]"

class t_COMP_OP (T):
    "%token COMP_OP [p1]"

class t_INDENT (T):
    "%token INDENT [p1]"

class t_NAME (T):
    "%token NAME [p1]"

class t_or (T):
    "%token or [p1]"

class t_while (T):
    "%token while [p1]"

class t_plus (T):
    "%token plus [p1]"

class t_comma (T):
    "%token comma [p1]"

class t_minus (T):
    "%token minus [p1]"

class p1 (Parsing.Precedence):
    "%right p1"
class suite (NT):
    "%start"
    def r_0 (self, *args):
        "%reduce suite stmt [p1]"
    def r_1 (self, *args):
        "%reduce stmt [p1]"
class suite_1 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce small_stmt simple_stmt simple_stmt_1 NEWLINE [p1]"
    def r_1 (self, *args):
        "%reduce NEWLINE INDENT suite DEDENT [p1]"
class stmt (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce small_stmt simple_stmt simple_stmt_1 NEWLINE [p1]"
    def r_1 (self, *args):
        "%reduce compound_stmt [p1]"
class simple_stmt (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce simple_stmt semicolon small_stmt [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class simple_stmt_1 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce semicolon [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class small_stmt (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce not_test and_test test testlist testlist_1 expr_stmt [p1]"
    def r_1 (self, *args):
        "%reduce print print_stmt_2 [p1]"
    def r_2 (self, *args):
        "%reduce pass [p1]"
class compound_stmt (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce if not_test and_test test colon suite_1 if_stmt if_stmt_1 [p1]"
    def r_1 (self, *args):
        "%reduce while not_test and_test test colon suite_1 while_stmt [p1]"
class if_stmt (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce if_stmt elif not_test and_test test colon suite_1 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class if_stmt_1 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce else colon suite_1 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class while_stmt (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce else colon suite_1 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class print_stmt (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce print_stmt comma not_test and_test test [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class print_stmt_1 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce comma [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class print_stmt_2 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce not_test and_test test print_stmt print_stmt_1 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class expr_stmt (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce expr_stmt equals not_test and_test test testlist testlist_1 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class testlist (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce testlist comma not_test and_test test [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class testlist_1 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce comma [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class test (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce test or not_test and_test [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class and_test (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce and_test and not_test [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class not_test (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce not not_test [p1]"
    def r_1 (self, *args):
        "%reduce atom term_1 expr_1 comparison [p1]"
class comparison (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce comparison comp_op atom term_1 expr_1 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class comp_op (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce COMP_OP [p1]"
    def r_1 (self, *args):
        "%reduce in [p1]"
    def r_2 (self, *args):
        "%reduce not in [p1]"
    def r_3 (self, *args):
        "%reduce is [p1]"
    def r_4 (self, *args):
        "%reduce is not [p1]"
class expr (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce plus [p1]"
    def r_1 (self, *args):
        "%reduce minus [p1]"
class expr_1 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce expr_1 expr atom term_1 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class term (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce splat [p1]"
    def r_1 (self, *args):
        "%reduce slash [p1]"
    def r_2 (self, *args):
        "%reduce percent [p1]"
    def r_3 (self, *args):
        "%reduce slashslash [p1]"
class term_1 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce term_1 term atom [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class atom_1 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce atom_1 STRING [p1]"
    def r_1 (self, *args):
        "%reduce STRING [p1]"
class atom (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce NAME [p1]"
    def r_1 (self, *args):
        "%reduce NUMBER [p1]"
    def r_2 (self, *args):
        "%reduce atom_1 [p1]"


spec = Parsing.Spec (sys.modules[__name__], skinny=False, logFile="t0.log", verbose=True)
