;; parser tables

(include "lib/core.scm")
(include "lib/pair.scm")
(include "lib/string.scm")
(include "lib/frb.scm")
(include "lib/symbol.scm")

;; parser tables

(datatype action
  (:shift int)
  (:reduce int int))

(datatype action-list
  (:nil)
  (:cons int (action) (action-list)))

(datatype goto
  (:nil)
  (:cons int int (goto)))

(define terminals #(
    'caret
    'slashslash
    'lshift
    'rshift
    'STRING
    'minus
    'percent
    'NUMBER
    '<e>
    '<$>
    'plus
    'vbar
    'slash
    'tilde
    'ampersand
    'splatsplat
    'splat
    'NAME
  ))
(define non-terminals #(
    'atom_52
    'term_28
    'atom_50
    'atom_54
    'and_expr_10
    'factor_41
    'term_32
    'term_30
    'factor_44
    'xor_expr_6
    'arith_expr_24
    '<S>
    'arith_expr_21
    'term_35
    'expr
    'shift_expr_17
    'expr_2
    'shift_expr_14
    'power_46
    'factor_39
  ))
(define actions
  (let ()
    (define C action-list:cons)
    (define N action-list:nil)
    (define S action:shift)
    (define R action:reduce)
    #(
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 16 (R 1 0) (C 15 (R 1 0) (C 14 (R 1 0) (C 12 (R 1 0) (C 11 (R 1 0) (C 10 (R 1 0) (C 9 (R 1 0) (C 6 (R 1 0) (C 5 (R 1 0) (C 4 (R 1 0) (C 3 (R 1 0) (C 2 (R 1 0) (C 1 (R 1 0) (C 0 (R 1 0) (N)))))))))))))))
      (C 17 (R 1 19) (C 13 (R 1 19) (C 10 (R 1 19) (C 7 (R 1 19) (C 5 (R 1 19) (C 4 (R 1 19) (N)))))))
      (C 16 (R 1 2) (C 15 (R 1 2) (C 14 (R 1 2) (C 12 (R 1 2) (C 11 (R 1 2) (C 10 (R 1 2) (C 9 (R 1 2) (C 6 (R 1 2) (C 5 (R 1 2) (C 3 (R 1 2) (C 2 (R 1 2) (C 1 (R 1 2) (C 0 (R 1 2) (N))))))))))))))
      (C 17 (R 1 19) (C 13 (R 1 19) (C 10 (R 1 19) (C 7 (R 1 19) (C 5 (R 1 19) (C 4 (R 1 19) (N)))))))
      (C 17 (R 1 5) (C 13 (R 1 5) (C 10 (R 1 5) (C 7 (R 1 5) (C 5 (R 1 5) (C 4 (R 1 5) (N)))))))
      (C 16 (R 1 2) (C 15 (R 1 2) (C 14 (R 1 2) (C 12 (R 1 2) (C 11 (R 1 2) (C 10 (R 1 2) (C 9 (R 1 2) (C 6 (R 1 2) (C 5 (R 1 2) (C 3 (R 1 2) (C 2 (R 1 2) (C 1 (R 1 2) (C 0 (R 1 2) (N))))))))))))))
      (C 16 (R 1 3) (C 15 (R 1 3) (C 14 (R 1 3) (C 12 (R 1 3) (C 11 (R 1 3) (C 10 (R 1 3) (C 9 (R 1 3) (C 6 (R 1 3) (C 5 (R 1 3) (C 4 (S 14) (C 3 (R 1 3) (C 2 (R 1 3) (C 1 (R 1 3) (C 0 (R 1 3) (N)))))))))))))))
      (C 16 (R 1 3) (C 15 (R 1 3) (C 14 (R 1 3) (C 12 (R 1 3) (C 11 (R 1 3) (C 10 (R 1 3) (C 9 (R 1 3) (C 6 (R 1 3) (C 5 (R 1 3) (C 3 (R 1 3) (C 2 (R 1 3) (C 1 (R 1 3) (C 0 (R 1 3) (N))))))))))))))
      (C 16 (R 0 18) (C 15 (S 15) (C 14 (R 0 18) (C 12 (R 0 18) (C 11 (R 0 18) (C 10 (R 0 18) (C 9 (R 0 18) (C 6 (R 0 18) (C 5 (R 0 18) (C 3 (R 0 18) (C 2 (R 0 18) (C 1 (R 0 18) (C 0 (R 0 18) (N))))))))))))))
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 16 (R 0 13) (C 14 (R 0 13) (C 12 (R 0 13) (C 11 (R 0 13) (C 10 (R 0 13) (C 9 (R 0 13) (C 6 (R 0 13) (C 5 (R 0 13) (C 3 (R 0 13) (C 2 (R 0 13) (C 1 (R 0 13) (C 0 (R 0 13) (N)))))))))))))
      (C 9 (S 19) (N))
      (C 17 (R 1 5) (C 13 (R 1 5) (C 10 (R 1 5) (C 7 (R 1 5) (C 5 (R 1 5) (C 4 (R 1 5) (N)))))))
      (C 16 (R 2 0) (C 15 (R 2 0) (C 14 (R 2 0) (C 12 (R 2 0) (C 11 (R 2 0) (C 10 (R 2 0) (C 9 (R 2 0) (C 6 (R 2 0) (C 5 (R 2 0) (C 4 (R 2 0) (C 3 (R 2 0) (C 2 (R 2 0) (C 1 (R 2 0) (C 0 (R 2 0) (N)))))))))))))))
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 16 (R 2 8) (C 14 (R 2 8) (C 12 (R 2 8) (C 11 (R 2 8) (C 10 (R 2 8) (C 9 (R 2 8) (C 6 (R 2 8) (C 5 (R 2 8) (C 3 (R 2 8) (C 2 (R 2 8) (C 1 (R 2 8) (C 0 (R 2 8) (N)))))))))))))
      (C 16 (R 2 8) (C 14 (R 2 8) (C 12 (R 2 8) (C 11 (R 2 8) (C 10 (R 2 8) (C 9 (R 2 8) (C 6 (R 2 8) (C 5 (R 2 8) (C 3 (R 2 8) (C 2 (R 2 8) (C 1 (R 2 8) (C 0 (R 2 8) (N)))))))))))))
      (C 16 (S 24) (C 14 (R 0 10) (C 12 (S 23) (C 11 (R 0 10) (C 10 (R 0 10) (C 9 (R 0 10) (C 6 (S 22) (C 5 (R 0 10) (C 3 (R 0 10) (C 2 (R 0 10) (C 1 (S 21) (C 0 (R 0 10) (N)))))))))))))
      (C 8 (R 2 11) (N))
      (C 16 (R 2 18) (C 14 (R 2 18) (C 12 (R 2 18) (C 11 (R 2 18) (C 10 (R 2 18) (C 9 (R 2 18) (C 6 (R 2 18) (C 5 (R 2 18) (C 3 (R 2 18) (C 2 (R 2 18) (C 1 (R 2 18) (C 0 (R 2 18) (N)))))))))))))
      (C 17 (R 1 6) (C 13 (R 1 6) (C 10 (R 1 6) (C 7 (R 1 6) (C 5 (R 1 6) (C 4 (R 1 6) (N)))))))
      (C 17 (R 1 7) (C 13 (R 1 7) (C 10 (R 1 7) (C 7 (R 1 7) (C 5 (R 1 7) (C 4 (R 1 7) (N)))))))
      (C 17 (R 1 1) (C 13 (R 1 1) (C 10 (R 1 1) (C 7 (R 1 1) (C 5 (R 1 1) (C 4 (R 1 1) (N)))))))
      (C 17 (R 1 1) (C 13 (R 1 1) (C 10 (R 1 1) (C 7 (R 1 1) (C 5 (R 1 1) (C 4 (R 1 1) (N)))))))
      (C 17 (R 1 7) (C 13 (R 1 7) (C 10 (R 1 7) (C 7 (R 1 7) (C 5 (R 1 7) (C 4 (R 1 7) (N)))))))
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 17 (R 1 6) (C 13 (R 1 6) (C 10 (R 1 6) (C 7 (R 1 6) (C 5 (R 1 6) (C 4 (R 1 6) (N)))))))
      (C 14 (R 0 15) (C 11 (R 0 15) (C 10 (S 31) (C 9 (R 0 15) (C 5 (S 30) (C 3 (R 0 15) (C 2 (R 0 15) (C 0 (R 0 15) (N)))))))))
      (C 16 (R 3 13) (C 14 (R 3 13) (C 12 (R 3 13) (C 11 (R 3 13) (C 10 (R 3 13) (C 9 (R 3 13) (C 6 (R 3 13) (C 5 (R 3 13) (C 3 (R 3 13) (C 2 (R 3 13) (C 1 (R 3 13) (C 0 (R 3 13) (N)))))))))))))
      (C 17 (R 1 12) (C 13 (R 1 12) (C 10 (R 1 12) (C 7 (R 1 12) (C 5 (R 1 12) (C 4 (R 1 12) (N)))))))
      (C 17 (R 1 12) (C 13 (R 1 12) (C 10 (R 1 12) (C 7 (R 1 12) (C 5 (R 1 12) (C 4 (R 1 12) (N)))))))
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 14 (R 0 4) (C 11 (R 0 4) (C 9 (R 0 4) (C 3 (S 36) (C 2 (S 35) (C 0 (R 0 4) (N)))))))
      (C 16 (R 0 13) (C 14 (R 0 13) (C 12 (R 0 13) (C 11 (R 0 13) (C 10 (R 0 13) (C 9 (R 0 13) (C 6 (R 0 13) (C 5 (R 0 13) (C 3 (R 0 13) (C 2 (R 0 13) (C 1 (R 0 13) (C 0 (R 0 13) (N)))))))))))))
      (C 17 (R 1 17) (C 13 (R 1 17) (C 10 (R 1 17) (C 7 (R 1 17) (C 5 (R 1 17) (C 4 (R 1 17) (N)))))))
      (C 17 (R 1 17) (C 13 (R 1 17) (C 10 (R 1 17) (C 7 (R 1 17) (C 5 (R 1 17) (C 4 (R 1 17) (N)))))))
      (C 14 (S 40) (C 11 (R 0 9) (C 9 (R 0 9) (C 0 (R 0 9) (N)))))
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 16 (S 24) (C 14 (R 4 10) (C 12 (S 23) (C 11 (R 4 10) (C 10 (R 4 10) (C 9 (R 4 10) (C 6 (S 22) (C 5 (R 4 10) (C 3 (R 4 10) (C 2 (R 4 10) (C 1 (S 21) (C 0 (R 4 10) (N)))))))))))))
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 11 (R 0 16) (C 9 (R 0 16) (C 0 (S 44) (N))))
      (C 16 (R 0 13) (C 14 (R 0 13) (C 12 (R 0 13) (C 11 (R 0 13) (C 10 (R 0 13) (C 9 (R 0 13) (C 6 (R 0 13) (C 5 (R 0 13) (C 3 (R 0 13) (C 2 (R 0 13) (C 1 (R 0 13) (C 0 (R 0 13) (N)))))))))))))
      (C 16 (R 0 13) (C 14 (R 0 13) (C 12 (R 0 13) (C 11 (R 0 13) (C 10 (R 0 13) (C 9 (R 0 13) (C 6 (R 0 13) (C 5 (R 0 13) (C 3 (R 0 13) (C 2 (R 0 13) (C 1 (R 0 13) (C 0 (R 0 13) (N)))))))))))))
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 11 (S 49) (C 9 (R 7 14) (N)))
      (C 16 (S 24) (C 14 (R 0 10) (C 12 (S 23) (C 11 (R 0 10) (C 10 (R 0 10) (C 9 (R 0 10) (C 6 (S 22) (C 5 (R 0 10) (C 3 (R 0 10) (C 2 (R 0 10) (C 1 (S 21) (C 0 (R 0 10) (N)))))))))))))
      (C 16 (S 24) (C 14 (R 0 10) (C 12 (S 23) (C 11 (R 0 10) (C 10 (R 0 10) (C 9 (R 0 10) (C 6 (S 22) (C 5 (R 0 10) (C 3 (R 0 10) (C 2 (R 0 10) (C 1 (S 21) (C 0 (R 0 10) (N)))))))))))))
      (C 16 (R 0 13) (C 14 (R 0 13) (C 12 (R 0 13) (C 11 (R 0 13) (C 10 (R 0 13) (C 9 (R 0 13) (C 6 (R 0 13) (C 5 (R 0 13) (C 3 (R 0 13) (C 2 (R 0 13) (C 1 (R 0 13) (C 0 (R 0 13) (N)))))))))))))
      (C 17 (S 6) (C 13 (S 5) (C 10 (S 4) (C 7 (S 3) (C 5 (S 2) (C 4 (S 1) (N)))))))
      (C 14 (R 5 15) (C 11 (R 5 15) (C 10 (S 31) (C 9 (R 5 15) (C 5 (S 30) (C 3 (R 5 15) (C 2 (R 5 15) (C 0 (R 5 15) (N)))))))))
      (C 14 (R 0 15) (C 11 (R 0 15) (C 10 (S 31) (C 9 (R 0 15) (C 5 (S 30) (C 3 (R 0 15) (C 2 (R 0 15) (C 0 (R 0 15) (N)))))))))
      (C 16 (S 24) (C 14 (R 0 10) (C 12 (S 23) (C 11 (R 0 10) (C 10 (R 0 10) (C 9 (R 0 10) (C 6 (S 22) (C 5 (R 0 10) (C 3 (R 0 10) (C 2 (R 0 10) (C 1 (S 21) (C 0 (R 0 10) (N)))))))))))))
      (C 16 (R 0 13) (C 14 (R 0 13) (C 12 (R 0 13) (C 11 (R 0 13) (C 10 (R 0 13) (C 9 (R 0 13) (C 6 (R 0 13) (C 5 (R 0 13) (C 3 (R 0 13) (C 2 (R 0 13) (C 1 (R 0 13) (C 0 (R 0 13) (N)))))))))))))
      (C 14 (R 6 4) (C 11 (R 6 4) (C 9 (R 6 4) (C 3 (S 36) (C 2 (S 35) (C 0 (R 6 4) (N)))))))
      (C 14 (R 0 15) (C 11 (R 0 15) (C 10 (S 31) (C 9 (R 0 15) (C 5 (S 30) (C 3 (R 0 15) (C 2 (R 0 15) (C 0 (R 0 15) (N)))))))))
      (C 16 (S 24) (C 14 (R 0 10) (C 12 (S 23) (C 11 (R 0 10) (C 10 (R 0 10) (C 9 (R 0 10) (C 6 (S 22) (C 5 (R 0 10) (C 3 (R 0 10) (C 2 (R 0 10) (C 1 (S 21) (C 0 (R 0 10) (N)))))))))))))
      (C 14 (R 0 4) (C 11 (R 0 4) (C 9 (R 0 4) (C 3 (S 36) (C 2 (S 35) (C 0 (R 0 4) (N)))))))
      (C 14 (R 0 15) (C 11 (R 0 15) (C 10 (S 31) (C 9 (R 0 15) (C 5 (S 30) (C 3 (R 0 15) (C 2 (R 0 15) (C 0 (R 0 15) (N)))))))))
      (C 14 (S 40) (C 11 (R 7 9) (C 9 (R 7 9) (C 0 (R 7 9) (N)))))
      (C 14 (R 0 4) (C 11 (R 0 4) (C 9 (R 0 4) (C 3 (S 36) (C 2 (S 35) (C 0 (R 0 4) (N)))))))
      (C 14 (S 40) (C 11 (R 0 9) (C 9 (R 0 9) (C 0 (R 0 9) (N)))))
      (C 11 (R 8 16) (C 9 (R 8 16) (C 0 (S 44) (N))))
   )))
(define goto
  (let ()
    (define C goto:cons)
    (define N goto:nil)
    #(
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 14 12 (C 8 11 (C 19 13 (N))))))))
      (N)
      (N)
      (N)
      (N)
      (N)
      (N)
      (N)
      (N)
      (C 18 16 (N))
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 8 17 (C 19 13 (N)))))))
      (C 13 18 (N))
      (N)
      (N)
      (N)
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 8 20 (C 19 13 (N)))))))
      (N)
      (N)
      (C 1 25 (C 6 26 (C 10 28 (C 7 27 (N)))))
      (N)
      (N)
      (N)
      (N)
      (N)
      (N)
      (N)
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 8 29 (C 19 13 (N)))))))
      (N)
      (C 15 33 (C 12 32 (N)))
      (N)
      (N)
      (N)
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 8 34 (C 19 13 (N)))))))
      (C 17 38 (C 4 37 (N)))
      (C 13 39 (N))
      (N)
      (N)
      (C 9 41 (N))
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 8 42 (C 19 13 (N)))))))
      (C 1 25 (C 6 26 (C 7 27 (N))))
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 8 43 (C 19 13 (N)))))))
      (C 16 45 (N))
      (C 13 46 (N))
      (C 13 47 (N))
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 8 48 (C 19 13 (N)))))))
      (N)
      (C 1 25 (C 6 26 (C 10 50 (C 7 27 (N)))))
      (C 1 25 (C 6 26 (C 10 51 (C 7 27 (N)))))
      (C 13 52 (N))
      (C 0 7 (C 2 8 (C 3 9 (C 5 10 (C 8 53 (C 19 13 (N)))))))
      (C 12 32 (N))
      (C 15 54 (C 12 32 (N)))
      (C 1 25 (C 6 26 (C 10 55 (C 7 27 (N)))))
      (C 13 56 (N))
      (C 17 38 (N))
      (C 15 57 (C 12 32 (N)))
      (C 1 25 (C 6 26 (C 10 58 (C 7 27 (N)))))
      (C 17 38 (C 4 59 (N)))
      (C 15 60 (C 12 32 (N)))
      (N)
      (C 17 38 (C 4 61 (N)))
      (C 9 62 (N))
      (N)
  )))


{a=terminals b=non-terminals c=actions d=goto}
